aboutsummaryrefslogtreecommitdiff
path: root/docker
diff options
context:
space:
mode:
authoryaourt <yaourt@users.noreply.github.com>2017-02-19 02:43:27 +0100
committer无闻 <u@gogs.io>2017-02-18 20:43:27 -0500
commit1841316f188538b572c784b6875a89f63a83c513 (patch)
treeb046b1e5ab304f797494fd6b0bb2c926779260aa /docker
parent0a2f87f9414b184759c45a4da63c72470557b0f1 (diff)
Provide an updated Dockerfile where Gogs is build with Go 1.8 (#4151)
In order to have an up to date Docker image based on alpine 3.5 and having Gogs built with Go 1.8 Refs: [ #4145 ]
Diffstat (limited to 'docker')
-rwxr-xr-xdocker/build-go.sh32
-rwxr-xr-xdocker/build.sh8
-rwxr-xr-xdocker/finalize.sh22
-rw-r--r--docker/no-pic.patch16
4 files changed, 75 insertions, 3 deletions
diff --git a/docker/build-go.sh b/docker/build-go.sh
new file mode 100755
index 00000000..22e3724d
--- /dev/null
+++ b/docker/build-go.sh
@@ -0,0 +1,32 @@
+#!/bin/sh
+# Build GO version as specified in Dockerfile
+
+set -x
+set -e
+
+# Components versions
+export GOLANG_VERSION="1.8"
+export GOLANG_SRC_URL="https://golang.org/dl/go$GOLANG_VERSION.src.tar.gz"
+export GOLANG_SRC_SHA256="406865f587b44be7092f206d73fc1de252600b79b3cacc587b74b5ef5c623596"
+
+
+# Install build tools
+apk add --no-cache --no-progress --virtual build-deps-go gcc musl-dev openssl go
+
+export GOROOT_BOOTSTRAP="$(go env GOROOT)"
+
+# Download Go
+wget -q "$GOLANG_SRC_URL" -O golang.tar.gz
+echo "$GOLANG_SRC_SHA256 golang.tar.gz" | sha256sum -c -
+tar -C /usr/local -xzf golang.tar.gz
+rm golang.tar.gz
+
+# Build
+cd /usr/local/go/src
+# see https://golang.org/issue/14851
+patch -p2 -i /app/gogs/build/docker/no-pic.patch
+./make.bash
+
+# Clean
+rm /app/gogs/build/docker/*.patch
+apk del build-deps-go
diff --git a/docker/build.sh b/docker/build.sh
index cb442d6e..2cc188d5 100755
--- a/docker/build.sh
+++ b/docker/build.sh
@@ -4,16 +4,18 @@ set -e
# Set temp environment vars
export GOPATH=/tmp/go
-export PATH=${PATH}:${GOPATH}/bin
+export PATH=/usr/local/go/bin:${PATH}:${GOPATH}/bin
export GO15VENDOREXPERIMENT=1
# Install build deps
-apk --no-cache --no-progress add --virtual build-deps build-base linux-pam-dev go
+apk --no-cache --no-progress add --virtual build-deps build-base linux-pam-dev
# Build Gogs
mkdir -p ${GOPATH}/src/github.com/gogits/
-ln -s /app/gogs/ ${GOPATH}/src/github.com/gogits/gogs
+ln -s /app/gogs/build ${GOPATH}/src/github.com/gogits/gogs
cd ${GOPATH}/src/github.com/gogits/gogs
+# Needed since git 2.9.3 or 2.9.4
+git config --global http.https://gopkg.in.followRedirects true
go get -v -tags "sqlite cert pam" ./...
make build TAGS="sqlite cert pam"
diff --git a/docker/finalize.sh b/docker/finalize.sh
new file mode 100755
index 00000000..afd18e73
--- /dev/null
+++ b/docker/finalize.sh
@@ -0,0 +1,22 @@
+#!/bin/sh
+# Finalize the build
+
+set -x
+set -e
+
+# Move to final place
+mv /app/gogs/build/gogs /app/gogs/
+mv /app/gogs/build/templates /app/gogs/
+mv /app/gogs/build/public /app/gogs/
+mv /app/gogs/build/docker /app/gogs/
+
+# Final cleaning
+rm -rf /app/gogs/build
+rm /app/gogs/docker/build.sh
+rm /app/gogs/docker/build-go.sh
+rm /app/gogs/docker/finalize.sh
+rm /app/gogs/docker/nsswitch.conf
+rm /app/gogs/docker/README.md
+
+rm -rf /tmp/go
+rm -rf /usr/local/go \ No newline at end of file
diff --git a/docker/no-pic.patch b/docker/no-pic.patch
new file mode 100644
index 00000000..74d30270
--- /dev/null
+++ b/docker/no-pic.patch
@@ -0,0 +1,16 @@
+diff --git a/src/cmd/link/internal/ld/lib.go b/src/cmd/link/internal/ld/lib.go
+index 14f4fa9..5599307 100644
+--- a/src/cmd/link/internal/ld/lib.go
++++ b/src/cmd/link/internal/ld/lib.go
+@@ -1272,6 +1272,11 @@ func hostlink() {
+ argv = append(argv, peimporteddlls()...)
+ }
+
++ // The Go linker does not currently support building PIE
++ // executables when using the external linker. See:
++ // https://github.com/golang/go/issues/6940
++ argv = append(argv, "-fno-PIC")
++
+ if l.Debugvlog != 0 {
+ l.Logf("%5.2f host link:", obj.Cputime())
+ for _, v := range argv { \ No newline at end of file